Gecode::Int::Linear::LinBoolView< XV, YV > Class Template Reference

Base-class for Boolean linear propagators. More...

`#include <linear.hh>`

## Public Member Functions

virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low linear).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| LinBoolView (Space &home, LinBoolView &p)
| Constructor for cloning p.
| LinBoolView (Home home, ViewArray< XV > &x, YV y, int c)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

ViewArray< XV > | x
| Boolean views.
YV | y
| View to compare number of assigned Boolean views to.
int | c
| Righthandside (constant part from Boolean views assigned to 1).

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class XV, class YV>
class Gecode::Int::Linear::LinBoolView< XV, YV >

Base-class for Boolean linear propagators.

Definition at line 1023 of file linear.hh.

## Constructor & Destructor Documentation

## LinBoolView() [1/2]

template<class XV, class YV>

Gecode::Int::Linear::LinBoolView< XV, YV >::LinBoolView | ( | Space & | home,
|  | LinBoolView< XV, YV > & | p )

inline protected

Constructor for cloning p.

Definition at line 60 of file bool-view.hpp.

## LinBoolView() [2/2]

template<class XV, class YV>

Gecode::Int::Linear::LinBoolView< XV, YV >::LinBoolView | ( | Home | home,
|  | ViewArray< XV > & | x,
|  | YV | y,
|  | int | c )

inline protected

Constructor for creation.

Definition at line 42 of file bool-view.hpp.

## Member Function Documentation

## cost()

template<class XV, class YV>

PropCost Gecode::Int::Linear::LinBoolView< XV, YV >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low linear).

Implements Gecode::Propagator.

Definition at line 68 of file bool-view.hpp.

## reschedule()

template<class XV, class YV>

void Gecode::Int::Linear::LinBoolView< XV, YV >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 74 of file bool-view.hpp.

## dispose()

template<class XV, class YV>

size_t Gecode::Int::Linear::LinBoolView< XV, YV >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 51 of file bool-view.hpp.

## Member Data Documentation

## x

template<class XV, class YV>

ViewArray<XV> Gecode::Int::Linear::LinBoolView< XV, YV >::x

protected

Boolean views.

Definition at line 1026 of file linear.hh.

## y

template<class XV, class YV>

YV Gecode::Int::Linear::LinBoolView< XV, YV >::y

protected

View to compare number of assigned Boolean views to.

Definition at line 1028 of file linear.hh.

## c

template<class XV, class YV>

int Gecode::Int::Linear::LinBoolView< XV, YV >::c

protected

Righthandside (constant part from Boolean views assigned to 1).

Definition at line 1030 of file linear.hh.

The documentation for this class was generated from the following files:

- gecode/int/linear.hh
- gecode/int/linear/bool-view.hpp